Bar Chart Race in JavaScript

Using ApexCharts with JavaScript

This Bar Chart Race example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var raceEntities = [
  'United States',
  'China',
  'Germany',
  'Japan',
  'France',
  'United Kingdom',
  'India',
  'Brazil',
  'Canada',
  'Italy',
]

// A fixed color per country. With distributed bars the color is applied by bar
// POSITION, but this is a race where the bars re-sort every tick, so raceFrame()
// re-orders this palette to match the current ranking below. That keeps each
// country's color stable as it rides up and down the ranks.
var raceColors = {
  'United States': '#3B82F6',
  China: '#EF4444',
  Germany: '#F59E0B',
  Japan: '#10B981',
  France: '#06B6D4',
  'United Kingdom': '#EC4899',
  India: '#14B8A6',
  Brazil: '#F97316',
  Canada: '#64748B',
  Italy: '#84CC16',
}

// A flag emoji per country, prepended to its axis label by
// yaxis.labels.formatter. SVG axis labels are plain text, so an emoji is the
// simplest way to put an icon in front of a label (real image flags would need
// custom DOM work). Emoji flags render on most platforms; a few Windows
// browsers show the two-letter country code instead.
var raceFlags = {
  'United States': '🇺🇸',
  China: '🇨🇳',
  Germany: '🇩🇪',
  Japan: '🇯🇵',
  France: '🇫🇷',
  'United Kingdom': '🇬🇧',
  India: '🇮🇳',
  Brazil: '🇧🇷',
  Canada: '🇨🇦',
  Italy: '🇮🇹',
}

// Persistent value per entity, nudged a little each tick so ranks swap
// gradually (a smooth race rather than a random shuffle).
var raceValues = {}
raceEntities.forEach(function (name, i) {
  raceValues[name] = 300 + (raceEntities.length - i) * 90
})

function raceFrame() {
  raceEntities.forEach(function (name) {
    raceValues[name] = Math.max(
      50,
      raceValues[name] + (Math.random() - 0.45) * 220,
    )
  })
  var ranked = raceEntities
    .map(function (name) {
      return { name: name, value: Math.round(raceValues[name]) }
    })
    .sort(function (a, b) {
      return b.value - a.value
    })
  return {
    categories: ranked.map(function (r) {
      return r.name
    }),
    data: ranked.map(function (r) {
      return r.value
    }),
    // Colors follow the ranking so each country keeps its own color (see above).
    colors: ranked.map(function (r) {
      return raceColors[r.name]
    }),
  }
}

var raceInitial = raceFrame()

var options = {
  series: [
    {
      name: 'Value',
      data: raceInitial.data,
    },
  ],
  chart: {
    id: 'horizontal-bar-race',
    type: 'bar',
    height: 420,
    animations: {
      dynamicAnimation: {
        speed: 800,
      },
    },
    toolbar: {
      show: false,
    },
  },
  plotOptions: {
    bar: {
      borderRadius: 4,
      borderRadiusApplication: 'end',
      horizontal: true,
      // Each bar gets its own color, taken from the `colors` palette by position.
      distributed: true,
    },
  },
  colors: raceInitial.colors,
  dataLabels: {
    enabled: true,
    // Riding to each bar's new rank is the default; counting the number up or
    // down from its previous value on every tick is the opt-in that makes it
    // read as a race.
    countUp: {
      enabled: true,
    },
  },
  title: {
    text: 'Bar Chart Race',
    align: 'left',
  },
  xaxis: {
    categories: raceInitial.categories,
  },
  yaxis: {
    labels: {
      // Prepend each country's flag emoji to its axis label.
      formatter: function (val) {
        return (raceFlags[val] || '') + '  ' + val
      },
    },
  },
  legend: {
    show: false,
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

var raceRuns = 0
var raceInterval = window.setInterval(function () {
  raceRuns++
  var frame = raceFrame()
  chart.updateOptions({
    series: [{ data: frame.data }],
    xaxis: { categories: frame.categories },
    colors: frame.colors,
  })

  if (raceRuns === 2 && window.isATest === true) {
    clearInterval(raceInterval)
  }
}, 1200)

Bar Chart Race in Vue

Using ApexCharts with Vue

This Bar Chart Race example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="bar"
        height="420"
        ref="chart"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>

    <div class="explanation">
      A "bar chart race": each tick re-sorts the entities by value and updates
      the chart. The bars slide to their new ranks and the left-hand category
      labels ride along with them (automatic whenever a reorder update runs with
      <code>dynamicAnimation</code> enabled). The value labels ride each bar
      too, which every bar chart does by default. What completes the race is
      <code>dataLabels.countUp</code>: opt into it and each number counts up or
      down from its previous value instead of switching.
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

var raceEntities = [
  'United States', 'China', 'Germany', 'Japan', 'France',
  'United Kingdom', 'India', 'Brazil', 'Canada', 'Italy'
]

// A fixed color per country. With distributed bars the color is applied by bar
// POSITION, but this is a race where the bars re-sort every tick, so raceFrame()
// re-orders this palette to match the current ranking below. That keeps each
// country's color stable as it rides up and down the ranks.
var raceColors = {
  'United States': '#3B82F6',
  'China': '#EF4444',
  'Germany': '#F59E0B',
  'Japan': '#10B981',
  'France': '#06B6D4',
  'United Kingdom': '#EC4899',
  'India': '#14B8A6',
  'Brazil': '#F97316',
  'Canada': '#64748B',
  'Italy': '#84CC16'
}

// A flag emoji per country, prepended to its axis label by
// yaxis.labels.formatter. SVG axis labels are plain text, so an emoji is the
// simplest way to put an icon in front of a label (real image flags would need
// custom DOM work). Emoji flags render on most platforms; a few Windows
// browsers show the two-letter country code instead.
var raceFlags = {
  'United States': '🇺🇸',
  'China': '🇨🇳',
  'Germany': '🇩🇪',
  'Japan': '🇯🇵',
  'France': '🇫🇷',
  'United Kingdom': '🇬🇧',
  'India': '🇮🇳',
  'Brazil': '🇧🇷',
  'Canada': '🇨🇦',
  'Italy': '🇮🇹'
}

// Persistent value per entity, nudged a little each tick so ranks swap
// gradually (a smooth race rather than a random shuffle).
var raceValues = {}
raceEntities.forEach(function (name, i) {
  raceValues[name] = 300 + (raceEntities.length - i) * 90
})

function raceFrame() {
  raceEntities.forEach(function (name) {
    raceValues[name] = Math.max(
      50,
      raceValues[name] + (Math.random() - 0.45) * 220
    )
  })
  var ranked = raceEntities
    .map(function (name) {
      return { name: name, value: Math.round(raceValues[name]) }
    })
    .sort(function (a, b) {
      return b.value - a.value
    })
  return {
    categories: ranked.map(function (r) { return r.name }),
    data: ranked.map(function (r) { return r.value }),
    // Colors follow the ranking so each country keeps its own color (see above).
    colors: ranked.map(function (r) { return raceColors[r.name] })
  }
}

var raceInitial = raceFrame()

export default {
components: {
apexchart: VueApexCharts,
},
data: function () {
return {
series: [{
  name: 'Value',
  data: raceInitial.data
}],
chartOptions: {
chart: {
  id: 'horizontal-bar-race',
  type: 'bar',
  height: 420,
  animations: {
    dynamicAnimation: {
      speed: 800
    }
  },
  toolbar: {
    show: false
  }
},
plotOptions: {
  bar: {
    borderRadius: 4,
    borderRadiusApplication: 'end',
    horizontal: true,
    // Each bar gets its own color, taken from the `colors` palette by position.
    distributed: true
  }
},
colors: raceInitial.colors,
dataLabels: {
  enabled: true,
  // Riding to each bar's new rank is the default; counting the number up or
  // down from its previous value on every tick is the opt-in that makes it
  // read as a race.
  countUp: {
    enabled: true
  }
},
title: {
  text: 'Bar Chart Race',
  align: 'left'
},
xaxis: {
  categories: raceInitial.categories
},
yaxis: {
  labels: {
    // Prepend each country's flag emoji to its axis label.
    formatter: function (val) {
      return (raceFlags[val] || '') + '  ' + val
    }
  }
},
legend: {
  show: false
}
},
}
},
mounted: function () {
  var me = this
  window.setInterval(function () {
    var frame = raceFrame()
    me.$refs.chart.updateOptions({
      series: [{ data: frame.data }],
      xaxis: { categories: frame.categories },
      colors: frame.colors
    })
  }, 1200)
},,
}
</script>

<style>
#chart {
  max-width: 650px;
  margin: 35px auto;
}
.explanation {
  max-width: 620px;
  margin: 0 auto 12px;
  font-size: 13px;
  color: #777;
}
</style>

Bar Chart Race in React

Using ApexCharts with React

This Bar Chart Race example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

var raceEntities = [
  'United States',
  'China',
  'Germany',
  'Japan',
  'France',
  'United Kingdom',
  'India',
  'Brazil',
  'Canada',
  'Italy',
]

// A fixed color per country. With distributed bars the color is applied by bar
// POSITION, but this is a race where the bars re-sort every tick, so raceFrame()
// re-orders this palette to match the current ranking below. That keeps each
// country's color stable as it rides up and down the ranks.
var raceColors = {
  'United States': '#3B82F6',
  China: '#EF4444',
  Germany: '#F59E0B',
  Japan: '#10B981',
  France: '#06B6D4',
  'United Kingdom': '#EC4899',
  India: '#14B8A6',
  Brazil: '#F97316',
  Canada: '#64748B',
  Italy: '#84CC16',
}

// A flag emoji per country, prepended to its axis label by
// yaxis.labels.formatter. SVG axis labels are plain text, so an emoji is the
// simplest way to put an icon in front of a label (real image flags would need
// custom DOM work). Emoji flags render on most platforms; a few Windows
// browsers show the two-letter country code instead.
var raceFlags = {
  'United States': '🇺🇸',
  China: '🇨🇳',
  Germany: '🇩🇪',
  Japan: '🇯🇵',
  France: '🇫🇷',
  'United Kingdom': '🇬🇧',
  India: '🇮🇳',
  Brazil: '🇧🇷',
  Canada: '🇨🇦',
  Italy: '🇮🇹',
}

// Persistent value per entity, nudged a little each tick so ranks swap
// gradually (a smooth race rather than a random shuffle).
var raceValues = {}
raceEntities.forEach(function (name, i) {
  raceValues[name] = 300 + (raceEntities.length - i) * 90
})

function raceFrame() {
  raceEntities.forEach(function (name) {
    raceValues[name] = Math.max(
      50,
      raceValues[name] + (Math.random() - 0.45) * 220,
    )
  })
  var ranked = raceEntities
    .map(function (name) {
      return { name: name, value: Math.round(raceValues[name]) }
    })
    .sort(function (a, b) {
      return b.value - a.value
    })
  return {
    categories: ranked.map(function (r) {
      return r.name
    }),
    data: ranked.map(function (r) {
      return r.value
    }),
    // Colors follow the ranking so each country keeps its own color (see above).
    colors: ranked.map(function (r) {
      return raceColors[r.name]
    }),
  }
}

var raceInitial = raceFrame()

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Value',
        data: raceInitial.data,
      },
    ],
    options: {
      chart: {
        id: 'horizontal-bar-race',
        type: 'bar',
        height: 420,
        animations: {
          dynamicAnimation: {
            speed: 800,
          },
        },
        toolbar: {
          show: false,
        },
      },
      plotOptions: {
        bar: {
          borderRadius: 4,
          borderRadiusApplication: 'end',
          horizontal: true,
          // Each bar gets its own color, taken from the `colors` palette by position.
          distributed: true,
        },
      },
      colors: raceInitial.colors,
      dataLabels: {
        enabled: true,
        // Riding to each bar's new rank is the default; counting the number up or
        // down from its previous value on every tick is the opt-in that makes it
        // read as a race.
        countUp: {
          enabled: true,
        },
      },
      title: {
        text: 'Bar Chart Race',
        align: 'left',
      },
      xaxis: {
        categories: raceInitial.categories,
      },
      yaxis: {
        labels: {
          // Prepend each country's flag emoji to its axis label.
          formatter: function (val) {
            return (raceFlags[val] || '') + '  ' + val
          },
        },
      },
      legend: {
        show: false,
      },
    },
  })

  React.useEffect(() => {
    const raceInterval = window.setInterval(() => {
      const frame = raceFrame()
      ApexCharts.exec('horizontal-bar-race', 'updateOptions', {
        series: [{ data: frame.data }],
        xaxis: { categories: frame.categories },
        colors: frame.colors,
      })
    }, 1200)
    return () => window.clearInterval(raceInterval)
  }, [])

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="bar"
          height={420}
        />
      </div>

      <div className="explanation">
        A "bar chart race": each tick re-sorts the entities by value and updates
        the chart. The bars slide to their new ranks and the left-hand category
        labels ride along with them (automatic whenever a reorder update runs
        with
        <code>dynamicAnimation</code> enabled). The value labels ride each bar
        too, which every bar chart does by default. What completes the race is
        <code>dataLabels.countUp</code>: opt into it and each number counts up
        or down from its previous value instead of switching.
      </div>
    </div>
  )
}

export default ApexChart

Bar Chart Race in Angular

Using ApexCharts with Angular

This Bar Chart Race example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private raceEntities: any = [
          'United States',
          'China',
          'Germany',
          'Japan',
          'France',
          'United Kingdom',
          'India',
          'Brazil',
          'Canada',
          'Italy',
        ];

  private raceColors: any = {
          'United States': '#3B82F6',
          China: '#EF4444',
          Germany: '#F59E0B',
          Japan: '#10B981',
          France: '#06B6D4',
          'United Kingdom': '#EC4899',
          India: '#14B8A6',
          Brazil: '#F97316',
          Canada: '#64748B',
          Italy: '#84CC16',
        };

  private raceFlags: any = {
          'United States': '🇺🇸',
          China: '🇨🇳',
          Germany: '🇩🇪',
          Japan: '🇯🇵',
          France: '🇫🇷',
          'United Kingdom': '🇬🇧',
          India: '🇮🇳',
          Brazil: '🇧🇷',
          Canada: '🇨🇦',
          Italy: '🇮🇹',
        };

  private raceValues: any = {};

  private raceFrame = (): any => {
          this.raceEntities.forEach(function (name) {
            this.raceValues[name] = Math.max(
              50,
              this.raceValues[name] + (Math.random() - 0.45) * 220,
            )
          })
          var ranked = this.raceEntities
            .map(function (name) {
              return { name: name, value: Math.round(this.raceValues[name]) }
            })
            .sort(function (a, b) {
              return b.value - a.value
            })
          return {
            categories: ranked.map(function (r) {
              return r.name
            }),
            data: ranked.map(function (r) {
              return r.value
            }),
            // Colors follow the ranking so each country keeps its own color (see above).
            colors: ranked.map(function (r) {
              return this.raceColors[r.name]
            }),
          }
        };

  private raceInitial: any = this.raceFrame();

  private raceRuns: any = 0;

  private raceInterval: any;

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Value',
              data: this.raceInitial.data,
            },
          ],
          chart: {
            id: 'horizontal-bar-race',
            type: 'bar',
            height: 420,
            animations: {
              dynamicAnimation: {
                speed: 800,
              },
            },
            toolbar: {
              show: false,
            },
          },
          plotOptions: {
            bar: {
              borderRadius: 4,
              borderRadiusApplication: 'end',
              horizontal: true,
              // Each bar gets its own color, taken from the `colors` palette by position.
              distributed: true,
            },
          },
          colors: this.raceInitial.colors,
          dataLabels: {
            enabled: true,
            // Riding to each bar's new rank is the default; counting the number up or
            // down from its previous value on every tick is the opt-in that makes it
            // read as a race.
            countUp: {
              enabled: true,
            },
          },
          title: {
            text: 'Bar Chart Race',
            align: 'left',
          },
          xaxis: {
            categories: this.raceInitial.categories,
          },
          yaxis: {
            labels: {
              // Prepend each country's flag emoji to its axis label.
              formatter: (val) => {
                return (this.raceFlags[val] || '') + '  ' + val
              },
            },
          },
          legend: {
            show: false,
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    this.raceEntities.forEach(function (name, i) {
            this.raceValues[name] = 300 + (this.raceEntities.length - i) * 90
          })

    this.raceInterval = window.setInterval(() => {
            this.raceRuns++
            var frame = this.raceFrame()
            this.chart.updateOptions({
              series: [{ data: frame.data }],
              xaxis: { categories: frame.categories },
              colors: frame.colors,
            })

            if (this.raceRuns === 2 && (window as any).isATest === true) {
              clearInterval(this.raceInterval)
            }
          }, 1200)
  }

  ngOnDestroy() {
    if (this.raceInterval) clearInterval(this.raceInterval);
  }
}